#ifndef _ASTERISK_SQL_H_
#define _ASTERISK_SQL_H_

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

typedef void* ast_sql_conn;
typedef void* ast_sql_result;
typedef void* ast_sql_row;

/* Connecting to the database and querying */

/* returns last error text. The result is valid only between calls to ast_sql_* */
const char*     ast_sql_lasterror   ();

/* return NULL on error. For details call ast_sql_lasterror() */
ast_sql_conn    ast_sql_connect     ( const char* type, const char* _connect_string );
ast_sql_result  ast_sql_query       ( ast_sql_conn conn, const char* query );

/* return !=0 on error. For details call ast_sql_lasterror() */
int             ast_sql_clearresult ( ast_sql_result result );
int             ast_sql_disconnect  ( ast_sql_conn conn );


/* Enumerating the record sets */

/* return NULL on error. For details call ast_sql_lasterror() */
ast_sql_row     ast_sql_fetch       ( ast_sql_result result );
int             ast_sql_isnull      ( ast_sql_row row, const char* name );

/* return the defaultValue argument in case of any error */
char*           ast_sql_getstring   ( ast_sql_row row, const char* name, const char* defaultValue );
int             ast_sql_getint      ( ast_sql_row row, const char* name, int defaultValue );
time_t          ast_sql_gettime     ( ast_sql_row row, const char* name, time_t defaultValue );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
